#!/usr/bin/env python
import subprocess
from time import sleep
from importlib import import_module
import os
from flask import Flask, render_template, Response
from RPi import GPIO
#from pizypwm import *
from flask import request
import json
# import camera driver
if os.environ.get('CAMERA'):
    Camera = import_module('camera_' + os.environ['CAMERA']).Camera
else:
    from camera import Camera

gazul = 0
naklonv = 10
infire = 1
class PWM:
    def __init__( self, pin ):
        self.pin = pin

    def set( self, value ):
        cmd = 'echo "%d=%.2f" > /dev/pi-blaster' % ( self.pin, value )
        os.system(cmd)




app = Flask(__name__, static_folder='static', static_url_path='/static')

@app.route('/')
def index():
    """Video streaming home page."""
    return render_template('index.html')


def gen(camera):
    """Video streaming generator function."""
    while True:
        frame = camera.get_frame()
        yield (b'--frame\r\n'
               b'Content-Type: image/jpeg\r\n\r\n' + frame + b'\r\n')


@app.route('/video_feed')
def video_feed():
    """Video streaming route. Put this in the src attribute of an img tag."""
    return Response(gen(Camera()),
                    mimetype='multipart/x-mixed-replace; boundary=frame')







@app.route('/fire',methods=['GET', 'POST'])
def fire():
    
     gazdv =  request.args['fire']
     
     g = gazdv
     fireb = PWM(4)
     sbros = int(g)
    # hpoi = 'zalup'+str(g)
     if (sbros==1):
         hpoi = 'BOMB LAUNCHED'
         fireb.set(0.15)
         sleep(1)
         fireb.set(0.05)
         sleep(0.5)
         fireb.set(0.00)
     else:
         hpoi = 'UNFIRE'
         fireb.set(0.00)
     print g
     return hpoi





@app.route('/staticip',methods=['GET', 'POST'])
def staticip():

     gazdv =  request.args['staticip']
     subprocess.call("/home/pi/static.sh", shell=True)
     g = gazdv
     print g
     return 'STATIC ENABLED'










@app.route('/stop',methods=['GET', 'POST'])
def stop():



     return 'STOP'


@app.route('/gazd',methods=['GET', 'POST'])
def gazd():

     gazdv =  request.args['gazd']
     g = float(gazdv)
     blasgaz = PWM(18)
     blasgaz.set(g)
     print g
     return 'GAZD'





@app.route('/naklon',methods=['GET', 'POST'])
def naklon():

     gazdv =  request.args['naklon']
     g = float(gazdv)
     naklonb = PWM(17)
     naklonb.set(g)
     print g
     return 'NAKLON'
@app.route('/pitch',methods=['GET', 'POST'])
def pitch():

     gazdv =  request.args['pitch']
     g = float(gazdv)
     pitchb = PWM(27)
     pitchb.set(g)
     print g
     return 'PITCH'
@app.route('/rotate',methods=['GET', 'POST'])
def rotate():

     rotate =  request.args['rotate']
     g = float(rotate)
     rotateb = PWM(22)
     rotateb.set(g)
     
     print g
     return 'ROTATE'


@app.route('/rezhimi',methods=['GET', 'POST'])
def rezhimi():

     rezhim =  request.args['rezhimi']
     g = float(rezhim)
     rezhimib = PWM(23)
     rezhimib.set(g)

     print g
     return 'REZHIMI'


@app.route('/armnaze',methods=['GET', 'POST'])
def armnaze():

     rezhimzoy =  request.args['rezhimi2']
     g = float(rezhimzoy)
     rezhimib2 = PWM(24)
     rezhimib2.set(g)

     print g
     return 'REZHIMI-2-ARM'

@app.route('/alt',methods=['GET', 'POST'])
def alt():

     alto =  request.args['alt1']
     g = float(alto)
     altrezhimib = PWM(23)
     altrezhimib.set(g)

     print g
     return 'ALTHOLD-ON'



@app.route('/auto',methods=['GET', 'POST'])
def auto_vz():

     altou =  request.args['auto1']
     g = float(altou)
     autoset = PWM(23)
     autoset.set(g)

     print g
     return 'AUTO-ON'


@app.route('/land',methods=['GET', 'POST'])
def land():

     landz =  request.args['land1']
     g = float(landz)
     autoland = PWM(23)
     autoland.set(g)

     print g
     return 'LAND-ON'

@app.route('/loiter',methods=['GET', 'POST'])
def loiter():

     loiterz =  request.args['loiter1']
     g = float(loiterz)
     autoloi = PWM(23)
     autoloi.set(g)

     print g
     return 'LOITER-ON'


@app.route('/stabil',methods=['GET', 'POST'])
def stabil():

     stabilzo =  request.args['stabil1']
     g = float(stabilzo)
     autostabil = PWM(23)
     autostabil.set(g)

     print g
     return 'STABIL-ON'

@app.route('/center',methods=['GET', 'POST'])
def center():

     centerz =  request.args['center1']
     g = float(centerz)
     c1 = PWM(17)
     c2 = PWM(27)
     c3 = PWM(22)
     c1.set(g)
     c2.set(g)
     c3.set(g)

     print g
     return 'CENTER-ON'



if __name__ == '__main__':
    app.run(host='0.0.0.0', threaded=True)
